#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; =======================================================================================
; Title .........: Sand Box Form Generator
; Description ...: Sand Box Form Generator
; Requirement(s).: compatible Autoit v3.3.14.2
; Author(s) .....: Giovanni Rossati (El Condor)
; Version........: 0.6.4
; Date...........: 4 January 2017
; =======================================================================================
#include-once
#include <Array.au3>
#include <WindowsConstants.au3>
#include "formGen.au3"
#include "formGenCheck.au3"
#Include <Array.au3>
$sandBox = "SandBox Form Generator"
$frm = GUICreate($sandBox, 550, 400, 250, 200)
GUISetBkColor(0xD3E2F9)
local $lBtn = 95
$btnGenerator = GUICtrlCreateButton("Parm generator", 10, 150, $lBtn)
$btnSample = GUICtrlCreateButton("Sample", 10, 175, $lBtn)
$btnTest = GUICtrlCreateButton("Test", 10, 200, $lBtn)
$btnCheck = GUICtrlCreateButton("Check", 10, 225, $lBtn)
$btnTimer = GUICtrlCreateButton("Sample with timers", 10, 250, $lBtn)
$chkGUI = GUICtrlCreateCheckbox("External GUI", 10, 290, $lBtn)
GUICtrlSetState($chkGUI,$GUI_CHECKED)
$testCallBack = GUICtrlCreateCheckbox("Test CallBack", 10, 320, $lBtn)
$flMenu = GUICtrlCreateMenu("&File")
$fineItem = GUICtrlCreateMenuItem("End", $flMenu)
$helpMenu = GUICtrlCreateMenu("?")
$infoItem = GUICtrlCreateMenuItem("&Info", $helpMenu)
$result = GUICtrlCreateEdit("", 110, 150, 380, 200,bitOr($ES_WANTRETURN,$WS_VSCROLL,$ES_MULTILINE,$ES_AUTOVSCROLL))
$font = "Courier New"
GUICtrlSetFont(-1,10,400, 0, $font)
$counter = 0
GUISetState()
While 1
	$msg = GUIGetMsg()
	Switch $msg
		Case $btnGenerator
			$records = "T,FieldName,Field Name,10,Field" & $counter & ";" _
					 & "T,LabelName,Label Name,20,Field " & $counter & ";" _
					 & "N,Length,Length,5,20;" _
					 & "CMB,Type,Type,20,Text,B=Button|BL=Button List|CKB=Check Box|CMB=Combo Box|" _
					 & "CMT=Combo Box modifiable|C=Comment|F=File|D=Folder|Date|N=Number|P=Password|R=Radio button|S=Slider|T=Text" _
					 & "|Time|U=Unmodifiable|X=eXtended text;" _
					 & "T,Default,Default,100;" _
					 & "T,Values," & mask("Values (for combo, button list, file, filter)") & ",100;" _
					 & "CKB,Mandatory,Mandatory,10;" _
					 & "Check,FieldName,,,Required"
			$aReturn = formGen("Sand Box",$records,-1,CallBack)
			$counter += 1
			If $aReturn.item("fg_button") <> "Cancel" Then
				$ris = $aReturn.Item("FieldName") & "," & (($aReturn.Item("LabelName") = "") ?$aReturn.Item("FieldName"):mask($aReturn.Item("LabelName"))) & "," & $aReturn.Item("Length")	; Name, Label, Length
				$ris =  $aReturn.Item("Type") & ","  & $ris		; Type
				$ris = $ris & "," & mask($aReturn.Item("Default")) 	; Default
				$ris = $ris & "," & mask($aReturn.Item("Values"))	; Combo values
				if $aReturn.Item("Mandatory") = 1 Then $ris = $ris & ";Required," & $aReturn.Item("FieldName")
				GUICtrlSetData($result,(GuiCtrlRead($result) = "") ? $ris : GuiCtrlRead($result) & ";" & $ris)
			EndIf
		Case $infoItem
			Credits()
		Case $btnSample
		   $records = "CMT,cmbStyles,Styles,,,Normal|Title|Title 1|Title 2|Title 3|List;" _
					 & "T,Styles,Selected styles,25;" _
					 & "CMT,Fontname,Font name,20,,Arial|Courier New|Times New Roman|Verdana;" _
					 & "N,Correction,,5,1,;" _
					 & "N,Fontsize,Font size,5,10;" _
					 & "Control,Fontsize,min=6,max=20;" _
					 & "Required,Fontsize;" _
					 & "CKB,Linkable,Linkable index,10,1;" _
					 & "Time,Time,,10,;" _
					 & "Date,Date,,10,;" _
					 & "T,bmPrefix,Bookmark prefix,10,CI_;" _
					 & "B,styleSet,Set,10,,addStyle;" _
					 & "C,Va,_;" _
					 & "R,RadioButton,,10,M,M=married|S=Single|W=Widow|U=Unknown;" _
					 & "After,styleSet,Styles;" _
					 & "Menu,File,&File;" _
					 & "SubMenu,About,&About,menuSample;"
			GUICtrlSetData($result,$records)
			Local  $defaults[5][2] = [[4,0],["Correction", 2], ["bmPrefix","xxl_"], ["RadioButton","U"],["Fontsize",12]]
			$aReturn = formGen("Sample",GuiCtrlRead($result),-1,"",100,0,$defaults)
			displayDict($aReturn, "Sand Box")
		Case $btnTest
		   $GUI = $frm
		   If GUICtrlRead($chkGUI) = $GUI_CHECKED Then $GUI = -1
		   $cb = ""
		   If GUICtrlRead($testCallBack) = $GUI_CHECKED Then $cb = "cbFunction"
		   $aReturn = formGen("Test",(GuiCtrlRead($result)<>"") ? GuiCtrlRead($result): "X,,30,U,Use Parm Button",$GUI,$cb,100,10)
		   displayDict($aReturn, "Sand Box")
		Case $btnCheck
		   msgbox(0,"",fhCheck((GuiCtrlRead($result)<>"") ? GuiCtrlRead($result):""))
		case $btnTimer
			$records = "N,newDelay,New delay for timer 1,7,10000;" _
					& "TB,swTimer2,Timer 2,,start,startStopTimer;" _
					& "B,Ok,Exit;" _
					& "B,Change,Set delay,,,setDelay;" _
					& "After,Change,newDelay;" _
					& "Timer,tim1,5000,handleTimer;" _
					& "Timer,tim2,4000,handleTimer,off;" _
					& "Menu,File,&File;" _
					& "SubMenu,Showguard,&Display timer status,ShowTimers;"
			GUICtrlSetData($result,$records)
		Case $GUI_EVENT_CLOSE,$fineItem
			MsgBox(0,$sandBox,"See you later alligator",1)
			ExitLoop
	EndSwitch
WEnd
Func CallBack($id)
	If $id < 0 Then Return
	$name = $fhDictWID.item($id)	; the file and folder control returns the button id
	if $name = "Type" Then
		$type = GetCtrlData($fhaRecords[$fhDictCRef.Item($name)])
		switch $type
			case "R"
				GUICtrlSetData(widgetID("Values"),"1=One|2=Two|3=Three")
			case "CMB", "CMT"
				GUICtrlSetData(widgetID("Values"),"Alpha|Beta|Gamma|Delta")
				GUICtrlSetData(widgetID("Default"),"Gamma")
			case "S"
				GUICtrlSetData(widgetID("Values"),"1 10")
			case "F"
				GUICtrlSetData(widgetID("Values"),"(*.jpg\59*.bmp)|Videos (*.avi\59*.mpg)")
			case "BL"
				GUICtrlSetData(widgetID("Values"),"Update|Insert|Delete")
		EndSwitch
	EndIf
EndFunc
Func displayDict($dict, $title="")
	_ArrayDisplay(getIniFormat($dict),$title)
EndFunc
Func cbFunction($msg)
	if $msg <> 0 Then
		if $msg = -1 Then MsgBox("0","","First call")
		if $msg = -2 Then MsgBox("0","","Request of data")
		if $msg = -3 Then MsgBox("0","","Last call")
		if $msg > 0 Then
		 $resp = $msg
		 $content = ""
		 If $fhDictWID.Exists($msg) Then
			$resp = $fhDictWID.Item($msg)
			$content = GUICtrlRead($msg)
		EndIf
		MsgBox("0",$resp,"Control " & $msg & @CRLF & $content)
		EndIf
	EndIf
EndFunc
Func addStyle($aData)
   $cmbStyles = $aData.ITem("cmbStyles")
   $styles = $aData.ITem("Styles")
   If  $cmbStyles <> "" And StringInStr($styles,$cmbStyles) = 0 Then
	  If $styles <> "" Then $styles &= ","
	  GUICtrlSetData(WidgetID("Styles"),$styles & $cmbStyles)
   EndIf
EndFunc
Func Credits($info = "Credits")
   MsgBox(0, $info, "Condor Informatique - Turin" _
				& @CRLF  & "Form Handler Sand Box"	_
				& @CRLF  & "Version 0.5.3 4 January 2018" _
				& @CRLF  & "Program developped with AutoIt3 v3.3.14.2")
EndFunc
Func menuSample($dict)
	displayDict($dict,$dict.Item("fg_button"))
EndFunc
Func handleTimer($dict)
	ConsoleWrite(StringFormat("%u %u %u %u:%u:%u Timer: %s",@MDAY,@MON,@YEAR,@HOUR,@MIN,@SEC,$dict.item("fg_button")) & @CRLF)
EndFunc
Func setDelay($dict)
	consolewrite(fg_TimerInterval("tim1",$dict.item("newDelay")) & @CRLF)
EndFunc
Func startStopTimer($dict)
	consolewrite(fg_TimerStatus("tim2",$dict.item("swTimer2")) & @CRLF)
EndFunc
Func showTimers($dict)
	ConsoleWrite(StringFormat("Timer tim1 delay: %u status: %s",fg_TimerInterval("tim1"),fg_TimerStatus("tim1") & @CRLF))
	ConsoleWrite(StringFormat("Timer tim2 delay: %u status: %s",fg_TimerInterval("tim2"),fg_TimerStatus("tim2") & @CRLF))
EndFunc